﻿using Falcon.SugarApi.ServiceCollectionExtend;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

namespace Falcon.SugarApi.TimedTask.TaskManager
{
    /// <summary>
    /// 服务注册扩展
    /// </summary>
    public static class ServiceCollectionExtensions
    {
        /// <summary>
        /// 注册后台任务服务，并同时注册任务管理
        /// </summary>
        /// <typeparam name="T">后台任务的类型</typeparam>
        /// <param name="services">服务集合</param>
        /// <returns>服务集合</returns>
        public static IServiceCollection AddTimedTaskWithManager<T>(this IServiceCollection services)
            where T : class {
            services.AddSingletonWith<T>(typeof(IHostedService),typeof(ITaskManager));
            return services;
        }
    }
}
